package com.trs.ggzyexchange.schedul;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.AreaDataName;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 招标文件/招标文件澄清与修改 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-02-16
 */
@Component
public class GcTenderbidfileSchedul   implements Job {

    private Logger logger = LoggerFactory.getLogger(GcTenderbidfileSchedul.class);

    @Autowired
    private GcTenderbidfileService gcTenderbidfileService;

    @Autowired
    private AreaDataName areaDataName;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private GcAttachmentService gcAttachmentService;
    @Autowired
    private ScheduledTashService scheduledTashService;

    public void queryPageListUpdateEs() throws JsonProcessingException {

        //查询当前在定时任务表当中的时间
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","gc_tenderbidfile");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                //查询表gcNoticeandfile表当中的最新时间
                time = gcTenderbidfileService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(time);
                scheduledTashTash.setTableNameValue("gc_tenderbidfile");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = gcTenderbidfileService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("gc_tenderbidfile");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }

        if(!ObjectUtils.isEmpty(time)){
            try {
                QueryWrapper<GcTenderbidfile> gcPerformanceQueryWrapper = new QueryWrapper<GcTenderbidfile>();
                gcPerformanceQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = gcTenderbidfileService.count(gcPerformanceQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                   try {
                       List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                       Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                   }catch (Exception e){
                       e.printStackTrace();
                   }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<GcTenderbidfile> page = new Page<GcTenderbidfile>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = gcTenderbidfileService.queryGcTenderbidfileAllListByTime(page,time);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            String projectName = record.getProjectName();
            if(!ObjectUtils.isEmpty(projectName)){
                record.setNoticeName(projectName);
            }
            record.setNoticeTypeCode(ClassIfy.BIDDING_DOCUMENTS.getCode());
            record.setNoticeTypeName(ClassIfy.BIDDING_DOCUMENTS.getName());
            record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
            record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
            String bidSectionCodes = record.getBidSectionCodes();
            int i1 = bidSectionCodes.indexOf(",");
            int i2 = bidSectionCodes.indexOf(";");
            int i3 = bidSectionCodes.indexOf("<br>");
            String splitBidSectionCode = null;
            boolean flag = false;
            String[] split = null;
            if(i1 > 0){
                split =  bidSectionCodes.split(",");
                flag = true;
            }
            if(i2 > 0){
                split =  bidSectionCodes.split(";");
                flag = true;
            }
            if(i3 > 0){
                split =  bidSectionCodes.split("<br>");
                flag = true;
            }
            if(!flag){
                split = new String[]{bidSectionCodes};
            }
            List<GcAttachment> attachmentList = new ArrayList<GcAttachment>();
            if(!ObjectUtils.isEmpty(split)){
                if(split.length >=1){
                    for (String bidSectionCode : split) {
                        try {
                            //通过标包编号查询对应的附件信息
                            QueryWrapper<GcAttachment> gcAttachmentQueryWrapper = new QueryWrapper<GcAttachment>();
                            gcAttachmentQueryWrapper.eq("BID_SECTION_CODE",bidSectionCode);
                            List<GcAttachment> list = gcAttachmentService.list(gcAttachmentQueryWrapper);
                            if(!ObjectUtils.isEmpty(list)){
                                attachmentList.addAll(list);
                            }
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                }
            }
            String file = "";
            for (GcAttachment gcAttachment : attachmentList) {
                String attachmentName = gcAttachment.getAttachmentName();
                String url = gcAttachment.getUrl();
                file += "<a href='"+ url +"'>"+ attachmentName +"</a><br/>";
            }
            record.setNoticeContent(file);
            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.GcTenderbidfileFlag){
                JobLock.GcTenderbidfileFlag = false;
                logger.info("执行GcTenderbidfile", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.GcTenderbidfileFlag = true;
            }else{
                logger.info("不执行GcTenderbidfile", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
